// Azureus Stats
///////////////////////////////////////////////////////////////////////////////////////////////////
// loadMain - first method called when gadget loads/reloads
///////////////////////////////////////////////////////////////////////////////////////////////////
function loadMain() {   
    // main gadget onload method (first method called every time the gadget is loaded/reloaded)
    
	//Variables
	var globalusername = "";
	var globalpassword = "";
	var globalurl = "";
	var globalport = "";
	var globalrate = "";
	var dlspeed;
	var ulspeed;
	var dlamount;
	var seedamount;
	var completamount;
	var dlseedcomplete;
	var staall;
	var stoall;
	var downlimit;
	var uplimit;

    // init settings event methods and data
    System.Gadget.settingsUI = "settings.htm";                              // set settings page
    System.Gadget.onSettingsClosed = procSettingsClosedEvent;               // set settings onclosed method

    genDocked();

}
///////////////////////////////////////////////////////////////////////////////////////////////////
// procSettingsClosedEvent - process settings closed event
///////////////////////////////////////////////////////////////////////////////////////////////////
function procSettingsClosedEvent(event){
    // process settings closed event
   if (event.closeAction == event.Action.commit) {
       loadMain();
   }
}
////////////////////////////////////////////////////////////
function genDocked()
////////////////////////////////////////////////////////////
{   // gen docked gadget layout
    // set gadget document styles
    document.body.style.width = "130px";                                          // set total gadget width
    document.body.style.height = "60px";                                           // set total gadget height
    document.body.style.backgroundImage="url(images/FlyoutBack.png)";                // set gadget background image

    // set main gadget frame styles (main gadget area minus above background frame)
    gadgetMainFrame.style.width = "115px";                                          // set main frame width
    gadgetMainFrame.style.height = "55px";                                         // set main frame height
    
    // set content frame styles (main gadget content area)
    gadgetContentFrame.style.width = "115px";                                       // set content frame width
    gadgetContentFrame.style.height = "55px"; 					// set content frame height
   
    // set gadget content visibility
    gadgetContentFrameDocked.style.display = "block";                               // display docked content
   
    // Read the settings
	globalusername = System.Gadget.Settings.read("globalusername");		// read settings data
	globalpassword = System.Gadget.Settings.read("globalpassword");		// read settings data
	globalurl = System.Gadget.Settings.read("globalurl");			// read settings data
	globalport = System.Gadget.Settings.read("globalport");			// read settings data
	globalrate = System.Gadget.Settings.read("globalrate");			// read settings data
    
    if (globalurl == "")
    {
        // Logon details are empty, tell users to configure
        document.getElementById("dockedLine1").innerHTML = " Enter Settings";
        document.getElementById("dockedLine2").innerHTML = "";    
        document.getElementById("dockedLine3").innerHTML = "";    
    }
    else
    {
        document.getElementById("dockedLine1").innerHTML = "Loading...";
        document.getElementById("dockedLine2").innerHTML = ""; 
        document.getElementById("dockedLine3").innerHTML = ""; 
        getData();
     }
}
////////////////////////////////////////////////////////////
function getData()
////////////////////////////////////////////////////////////
{      
//Assume everything is ok, so start the AJAX call to the webpage
XMLHttp = new ActiveXObject("Microsoft.XMLHTTP");
// Construct the URL
globalURL ="http://" + globalusername + ":" + globalpassword + "@" + globalurl + ":" + globalport + "/" ;

XMLHttp.onreadystatechange = function() 
{
	    if (XMLHttp.readyState == 4)
	    {
            if (XMLHttp.status == 200) 
			{
			parseData();
			}
			else 
			{
            document.getElementById("dockedLine1").innerHTML = "Error";
            document.getElementById("dockedLine2").innerHTML = "Check"; 
            document.getElementById("dockedLine3").innerHTML = "Settings"; 
			}
		}
}
XMLHttp.open("POST", globalURL, true);

//Set the request header so that it's not cached in InternetExplorer
XMLHttp.setRequestHeader("If-Modified-Since", "Sat, 1 Jan 2000 00:00:00 GMT");
XMLHttp.send(null); 

// Call the URL based on the user configured update frequency.
refreshrate=globalrate*1000
window.setTimeout(getData, refreshrate);	          		
}
////////////////////////////////////////////////////////////    
function parseData()
////////////////////////////////////////////////////////////
{

// Split up the large Array into seperate lines by the carriage return
var Results = XMLHttp.responsetext;
var subStringFirstPart;
var subStringSecondPart;               
// dlspeed
subStringFirstPart = Results.indexOf("<span class=totals>") + 33;
subStringSecondPart = Results.indexOf("B/s", subStringFirstPart);
dlspeed = Results.substring(subStringFirstPart, subStringSecondPart +3); 

// ulspeed 
subStringFirstPart = Results.indexOf("down<br>") + 22;
subStringSecondPart = Results.indexOf("B/s", subStringFirstPart);
ulspeed = Results.substring(subStringFirstPart, subStringSecondPart +3); 

// dlamount 
subStringFirstPart = Results.indexOf("Downloads</a> ") + 15;
subStringSecondPart = Results.indexOf("</li>", subStringFirstPart);
dlamount = Results.substring(subStringFirstPart, subStringSecondPart -1); 

// seedamount
subStringFirstPart = Results.indexOf("Seeds</a> ") + 11;
subStringSecondPart = Results.indexOf("</li>", subStringFirstPart );
seedamount = Results.substring(subStringFirstPart, subStringSecondPart -1);  

// dlseedcomplete
dlseedcomplete = "Down:" + dlamount +  " Seed:" + seedamount;

// All ok. display details on sidebar
document.getElementById("dockedLine1").innerHTML = "<b> DL: </b>" + dlspeed ;
document.getElementById("dockedLine2").innerHTML = "<b> UL: </b>" + ulspeed ;
document.getElementById("dockedLine3").innerHTML = " " + dlseedcomplete;
}